using System;

/// <summary>
///    This program prints a couple mathematical sequences.
/// </summary>
public class MathSequences
{
    public static void Main()
    {
		string input;
		int index;
		int number;
		int choice;
		int count = 0;

		do 
		{
			// Print menu.
			Console.WriteLine("\nMath Sequences\n");
			Console.WriteLine("1 - Fibonacci");
			Console.WriteLine("2 - Squares");

			Console.WriteLine("3 - Exit\n");

			Console.Write("Please Choose (1, 2, or 3):  ");

			input = Console.ReadLine();
			choice = Int32.Parse(input);

			// Figure out what user wanted.
			switch (choice)
			{
				// Print Fibonnaci Sequence
				case 1:
					int temp;
					int lastnum;
					int fibnum;

					Console.WriteLine("\nFibonnaci Sequence\n");

					Console.Write("How many numbers? ");
					input = Console.ReadLine();
					number = Int32.Parse(input);

					for (index=0, lastnum=0, fibnum=1; index < number; index++);
					{
						temp = fibnum;
						fibnum += lastnum;
						lastnum = temp;

						Console.WriteLine("{0}: {1}", index+1, fibnum );
					}

					break;
				// Print Squared numbers sequence
				case 2:
					const int maxSquare = 46352; // point of int overflow
					
					Console.WriteLine("Squared Number Sequence");

					Console.Write("How many numbers? ");
					input = Console.ReadLine();
					number = Int32.Parse(input);

					for (index=0;index < number && index < maxSquare; index++)
					{
						Console.WriteLine("{0}: {1}", index+1, index*index );
					}
					if (number >= maxSquare)
					{
						Console.WriteLine("Overflow: Enter a number less than {0}!", maxSquare);
					}
					break;
				// Exit Program
				case 3:
					Console.WriteLine("\nGoodBye\n");
					break;
				// User entered bad data
				default:
					Console.WriteLine("No, no , no - That just won't do!");
					break;
			} // end switch

		// Keep going until user wants to quit
		} while (choice != 3); 

		// Keep console window open
		Console.ReadLine();
        return;
    }
}
