using System;

/// <summary>
///    Summary description for Class1.
/// </summary>
public class DelegatesAndEvents
{
    public static int Main(string[] args)
    {
		// create main menu
		Menu myMenu = new Menu("Financial Sites");

		// create data object
		SiteManager sm = new SiteManager();

		// create menu items
		MenuItem addMenu = new MenuItem("Add");
		MenuItem delMenu = new MenuItem("Delete");
		MenuItem modMenu = new MenuItem("Modify");
		MenuItem seeMenu = new MenuItem("View");

		// add events
		addMenu.MenuSelection += new MenuHandler(sm.AddSite);
		delMenu.MenuSelection += new MenuHandler(sm.DeleteSite);
		modMenu.MenuSelection += new MenuHandler(sm.ModifySite);
		seeMenu.MenuSelection += new MenuHandler(sm.ViewSites);

		myMenu.Add(addMenu);
		myMenu.Add(delMenu);
		myMenu.Add(modMenu);
		myMenu.Add(seeMenu);

		myMenu.Run();

        return 0;
    }
}