using System;
using System.Collections;

public class Menu
{
	ArrayList menuItems = new ArrayList();
	string title;
	
    public Menu(string title)
    {
		this.title = title;
    }

	public string Title 
	{
		get 
		{
			return Title;
		}
		set 
		{
			title = value;
		}
	}

	public void Add(MenuItem menu) 
	{
		menuItems.Add(menu);
	}

	public void Run() 
	{
		String choice;
		
		do {
			Console.WriteLine("{0}\n", title);

			foreach(MenuItem menu in menuItems)
			{
				Console.WriteLine("{0} - {1}", menuItems.IndexOf(menu), menu.Text);
			}
			Console.WriteLine("Q - Quit");

			Console.Write("\nPlease Choose:  ");
			
			choice = Console.ReadLine();

			if (choice.ToUpper() != "Q")
			{
				((MenuItem)menuItems[Int32.Parse(choice)]).Fire();
			}

		} while (choice != "Q");
	}
}
