using System;

public struct Currency
{
    private double amount;

    public Currency(double amount)
    {
        this.amount = amount;
    }

    public override string ToString()
    {
        return String.Format("{0:C}", amount);
    }

    public static Currency operator+(Currency c1, Currency c2)
    {
        Currency cur = new Currency();
        cur.Amount = c1.Amount + c2.Amount;
        return cur;
    }

    public double Amount
    {
        get
        {
            return amount;
        }
        set
        {
            amount = value;
        }
    }
}

public class StructExample
{
    public static int Main(string[] args)
    {
        Currency myCurrency1 = new Currency(2.0);
        Currency myCurrency2 = new Currency(3.62);

        Currency myCurrency3 = myCurrency1 + myCurrency2;

        Console.WriteLine("Amount = {0}", myCurrency3);

        return 0;
    }
}
