using System;

public interface IMoney 
{
	// No Members
}

public struct Currency : IMoney
{
	private double amount;

	public Currency(double amount) 
	{
		this.amount = amount;
	}

	public static implicit operator Currency(double dbl) 
	{
		return new Currency(dbl);
	}

	public static explicit operator float(Currency curr) 
	{
		return (float)curr.Amount;
	}

	public override string ToString() 
	{
		return String.Format("{0:C}", amount); 
	}

	public static Currency operator+(Currency c1, Currency c2) 
	{
		Currency cur = new Currency();
		cur.Amount = c1.Amount + c2.Amount;

		return cur;
	}

	public double Amount 
	{
		get 
		{
			return amount;
		}
		set 
		{
			amount = value;
		}
	}
}

/// <summary>
///    Summary description for Class1.
/// </summary>
public class Conversions
{
    public Conversions()
    {
        //
        // TODO: Add Constructor Logic here
        //
    }

	enum CurrencyType 
	{
		Dollar, Euro, Franc, Lire, Yen
	}

    public static int Main(string[] args)
    {
		Currency myCurrency;
		double   myDouble;
		float    myFloat;

		myCurrency = 9.3f;
		Console.WriteLine("myCurrency: {0}", myCurrency);

		myFloat = (float)myCurrency;
		Console.WriteLine("myFloat: {0}", myFloat);

		myDouble = (double)myCurrency;
		Console.WriteLine("myDouble: {0}", myDouble);


/*
		//int  myInt = 5;
		//long myLong = myInt;

		//Console.WriteLine("myLong: {0}", myLong);

		//long myLong = 5;
		//int  myInt  = (int)myLong;

		//Console.WriteLine("myInt: {0}", myInt);

		//int  mySigned = -1;
		//uint myUnsigned = (uint)mySigned;  // myUnsigned = 4294967295

		//Console.WriteLine("myUnsigned: {0}", myUnsigned);

		//ushort myShort1 = 3, myShort2 = 5;
		//int result = myShort1 + myShort2;
		//ushort result = myShort1 + myShort2;
		//ushort result = (ushort)(myShort1 + myShort2);
		char myChar = 'x';
		object objChar = myChar;

		int myInt = (int)objChar;
		//byte myByte = (char)objChar;
		Console.WriteLine("myInt: {0}", myInt);
*/
/*
		int myInt = 7;
		object objInt = myInt;
		long myLong = (int)objInt;
		//myLong = (long)objInt;  // InvalidCastException

		//float myFloat = 2.3f;
		//object objFloat = myFloat;
		//myLong = (long)(float)objFloat;

		IMoney myMoney = new Currency(10.25d);

		CurrencyType myCurrType = 0;  // myCurrType = CurrencyType.Dollar

		float myFloat;
		double posInfinity = 999999999999999999999999999999999999999.0;
		myFloat = (float)posInfinity;
		Console.WriteLine("myFloat = posInfinity: {0}", myFloat);

		double negInfinity = -999999999999999999999999999999999999999.0;
		myFloat = (float)negInfinity;
		Console.WriteLine("myFloat = negInfinity: {0}", myFloat);
		
		double zeroDouble = 0.0000000000000000000000000000000000000000000001;
		myFloat = (float)zeroDouble;
		Console.WriteLine("myFloat = zeroDouble: {0}", myFloat);

		double myDouble = Double.NaN;
		myFloat = (float)myDouble;
		Console.WriteLine("myFloat : {0}", myFloat);

		try 
		{
			decimal myDecimal;
			double posInfinity = 999999999999999999999999999999999999999.0;
			double negInfinity = -999999999999999999999999999999999999999.0;
			double zeroDouble = 0.0000000000000000000000000000000000000000000001;
			double tooLarge = 99999999999999999999999999999.0;
			double doubleNaN = Double.NaN;
			//myDecimal = (decimal)posInfinity; // OverflowException
			//myDecimal = (decimal)negInfinity; // OverflowException
			//myDecimal = (decimal)zeroDouble;
			//Console.WriteLine("myDecimal = zeroDouble: {0}", myDecimal);
			//myDecimal = (decimal)tooLarge; //Overflow
			myDecimal = (decimal)doubleNaN; //Overflow
		}
		catch (InvalidCastException e) 
		{
			Console.WriteLine("InvalidCastException: {0}", e.Message);
		}
		catch (OverflowException e) 
		{
			Console.WriteLine("OverflowException: {0}", e.Message);
		}
		catch (Exception e) 
		{
			Console.WriteLine("General Exception: {0}", e.Message);
		}
*/

		Console.ReadLine();

		return 0;
    }
}
