using System;
using System.Windows.Forms;
using System.ComponentModel;
using System.Drawing;

public class FirstForm : Form
{
    private Container components;
    private Label     howdyLabel;

    public FirstForm()
    {
        InitializeComponent();
    }

    private void InitializeComponent()
    {
        components = new Container ();
        howdyLabel = new Label ();

        howdyLabel.Location  = new Point (12, 116);
        howdyLabel.Text      = "Howdy, Partner!";
        howdyLabel.Size      = new Size (267, 40);
        howdyLabel.AutoSize  = true;
        howdyLabel.Font      = new Font (
            "Microsoft Sans Serif", 
            26, System.
            Drawing.FontStyle.Bold);
        howdyLabel.TabIndex  = 0;
        howdyLabel.Anchor    = AnchorStyles.None;
        howdyLabel.TextAlign = HorizontalAlignmentContentAlignment.MiddleCenter;

        Text = "First Form";
        Controls.Add (howdyLabel);
    }

    public static void Main()
    {
        Application.Run(new FirstForm());
    }
}
