using System;
using WebSites;

public class SiteManager {
	
	SiteList sites = new SiteList();
	
	public SiteManager() 
	{
		this.sites = new WebSites.SiteList();
		this.sites[this.sites.NextIndex] = new WebSite("Joe", "http://www.mysite.com", "Great Site!");
		this.sites[this.sites.NextIndex] = new WebSite("Don", "http://www.dondotnet.com", "okay.");
		this.sites[this.sites.NextIndex] = new WebSite("Bob", "www.bob.com", "No http://");
	}

	public WebSite this[int index] 
	{
		get 
		{
			return sites[index];
		}
	}

	public int Count 
	{
		get 
		{
			return sites.NextIndex;
		}
	}
	
	public void AddSite(string siteName, string url, string description)
	{
		sites[sites.NextIndex] = new WebSite(siteName, url, description);
	}
	
	public void DeleteSite(int index)
	{
		if (index <= sites.NextIndex)
			sites.Remove(index);
	}
	
	public void ModifySite()
	{
		Console.WriteLine("Modifying Sites.");
	}
}
