namespace CodeBehind
{
    using System;
    using System.Collections;
    using System.ComponentModel;
    using System.Data;
    using System.Data.SqlClient;
    using System.Drawing;
    using System.Web;
    using System.Web.SessionState;
    using System.Web.UI;
    using System.Web.UI.WebControls;
    using System.Web.UI.HtmlControls;

    public class WebForm1 : System.Web.UI.Page
    {
        protected DropDownList tableDropList;
        protected Repeater     NwRepeater;
        protected DataGrid     NwDataGrid;
        protected Label        tableLabel;

        public WebForm1()
        {
            Page.Init += new System.EventHandler(Page_Init);
        }

        protected void Page_Init(object sender, EventArgs e)
        {
            InitializeComponent();
        }

        private void InitializeComponent()
        {
            this.Load +=
                new System.EventHandler(this.Page_Load);
            this.tableDropList.SelectedIndexChanged +=
                new System.EventHandler(
                    this.tableDropList_SelectedIndexChanged);
        }

        private void LoadTableData()
        {
            string selectedTable =
                tableDropList.SelectedItem.Text;
            try
            {
                SqlConnection conn = new SqlConnection("
                    Data Source=localhost;
                    User Id=sa;
                    Password=;
                    Initial Catalog=northwind");
                DataSet nwDs = new DataSet();
                SqlDataAdapter  nwDa = new SqlDataAdapter (
                    "SELECT * FROM " + selectedTable, conn);

                nwDa.Fill(nwDs, selectedTable);

                NwDataGrid.DataSource =
                    nwDs.Tables[selectedTable].DefaultView;
                NwDataGrid.DataBind();
            }
            catch (SqlException sqle)
            {
                Response.Write("Load_Data SqlException: " +
                                sqle.Message);
            }
            catch (Exception ge)
            {
                Response.Write("Load_Data Generic Exception: " +
                                ge.Message);
            }
        }

        private void Page_Load(object sender,
                               System.EventArgs e)
        {
            LoadTableData();
        }

        protected void tableDropList_SelectedIndexChanged(
            object sender, System.EventArgs e)
        {
            LoadTableData();
        }
    }
}
