using System;
using System.Runtime.Remoting;
using Host;

namespace HostedClient
{
	/// <summary>
	/// Client for a Hosted Remote Server.
	/// </summary>
	class HostedClient
	{
		static void Main(string[] args)
		{
			Type   type = typeof(HostedServer);
			String url  = "http://localhost:8000/HostedServer/HostedServer.soap";

			RemotingConfiguration.Configure("HostedClient.exe.config");

			HostedServer hostedServer = (HostedServer)Activator.GetObject(type, url);
			Console.WriteLine(hostedServer.getServerResponse());
			Console.ReadLine();
		}
	}
}
