using System;
using System.Collections;
using System.Text;
using System.Net.Sockets;

	/// <summary>
	///		Summary description for Class1.
	/// </summary>
class MoneyServer
{
	ArrayList talk  = new ArrayList();

	public MoneyServer () 
	{
		talk.Add("A penny saved is too small, make it a buck.");
		talk.Add("Keep your wooden nickel.  It'll be worth something someday.");
		talk.Add("It's your dime, but you're better off dialing 10-10-XXX.");
	}

	static void Main(string[] args)
	{
		MoneyServer mSvr = new MoneyServer();

		ASCIIEncoding ASCII = new ASCIIEncoding();

		Byte[] inStream  = new Byte[256];
		Byte[] outStream = new Byte[256];
		Random rnd;
		string reqString = "";
		int index;

		TcpListener tcpl = new TcpListener(2010);
		tcpl.Start();
		Console.WriteLine("Server is Running...");

		do 
		{
			try 
			{
				Socket sock = tcpl.AcceptSocket();

				int count = sock.Receive( inStream, inStream.Length, 0 );
				reqString = ASCII.GetString(inStream, 0, count);

				Console.WriteLine(reqString);

				rnd = new Random();
				index = rnd.Next(mSvr.talk.Count);

				outStream = ASCII.GetBytes( (string)mSvr.talk[index] );
				sock.Send( outStream, outStream.Length, 0 );
			}
			catch (Exception e) 
			{
				Console.WriteLine("Generic Exception Message: {0}", e.Message);
			}

		} while (reqString != "bye");

		tcpl.Stop();
	}
}
