using System;
using System.IO;
using System.Net;
using System.Text;

	/// <summary>
	///		Reads a web page.
	/// </summary>
class SiteReader
{
	static void Main(string[] args)
	{
		try 
		{
			ASCIIEncoding ASCII = new ASCIIEncoding();
			byte[] buf = new byte[2048];

			HttpWebRequest httpReq = 
				(HttpWebRequest)WebRequest.Create("http://localhost/howdy_partner.htm");

			HttpWebResponse httpResp = (HttpWebResponse)httpReq.GetResponse();

			Stream httpStream = httpResp.GetResponseStream();

			int count = httpStream.Read(buf, 0, buf.Length);

			Console.WriteLine(ASCII.GetString(buf, 0, count));
		}
		catch (Exception e) 
		{
			Console.WriteLine("Generic Exception: {0}", e.Message);
		}
		Console.ReadLine();
	}
}
