using System;

public class DisposableClass: IDisposable
{
	public void Dispose() 
	{
		Console.WriteLine("DisposableClass is being disposed.");
		GC.SuppressFinalize(this);
	}

	~DisposableClass()
	{
		Dispose();
	}
}
