using System;

class DisposePattern
{
	static void Main(string[] args)
	{
		DisposableClass dc = new DisposableClass();

		try 
		{
			if (dc is IDisposable) 
			{
				Console.WriteLine("DisposableClass is IDisposable");
			}
		}
		finally 
		{
			dc.Dispose();
		}

		Console.ReadLine();
	}
}
