using System;

public class SiteManager {
	
	SiteList sites = new SiteList();
	
	public SiteManager() 
	{
		this.sites = new SiteList();
		this.sites[this.sites.NextIndex] = new WebSite("Joe", "http://www.mysite.com", "Great Site!");
		this.sites[this.sites.NextIndex] = new WebSite("Don", "http://www.dondotnet.com", "okay.");
		this.sites[this.sites.NextIndex] = new WebSite("Bob", "www.bob.com", "No http://");
	}
	
	public void AddSite(object sender, EventArgs e)
	{
		string siteName;
		string url;
		string description;
		
		Console.Write("Please Enter Site Name: ");
		siteName = Console.ReadLine();
		
		Console.Write("Please Enter URL: ");
		url = Console.ReadLine();
		
		Console.Write("Please Enter Description: ");
		description = Console.ReadLine();
		
		sites[sites.NextIndex] = new WebSite(siteName, url, description);
	}
	
	public void DeleteSite(object sender, EventArgs e)
	{
		string choice;
		
		do
		{
			Console.WriteLine("\nDeletion Menu\n");
		
			DisplayShortList();
		
			Console.Write("\nPlease select an item to delete:  ");
		
			choice = Console.ReadLine();
		
			if (choice == "Q" || choice == "q")
				break;
		
			if (Int32.Parse(choice) <= sites.NextIndex)
				sites.Remove(Int32.Parse(choice)-1);
				
		} while (true);
	}
	
	public void ModifySite(object sender, EventArgs e)
	{
		Console.WriteLine("Modifying Sites.");
	}
	
	public void ViewSites(object sender, EventArgs e)
	{
		Console.WriteLine("");
		for (int i=0; i < sites.NextIndex; i++)
		{
			Console.WriteLine("Site: {0}", sites[i].ToString());
		}
		Console.WriteLine("");
	}
	
	private void DisplayShortList()
	{
		for (int i=0; i < sites.NextIndex; i++)
		{
			Console.WriteLine("{0} - {1}", i+1, sites[i].ToString());
		}
		Console.WriteLine("Q - Quit (Back To Main Menu)");
	}
	
}
