using System;
using System.Drawing;
using System.ComponentModel;
using System.Windows.Forms;

public class AddForm : Form
{
    private Container components;
    public  TextBox   descriptionTextbox;
    public  TextBox   addressTextbox;
    public  TextBox   sitenameTextbox;
    private Button    cancelButton;
    private Button    okButton;
    private Label     descriptionLabel;
    private Label     addressLabel;
    private Label     sitenameLabel;

    public AddForm()
    {
        InitializeComponent();
    }

    public override void Dispose()
    {
        base.Dispose();
        components.Dispose();
    }

    private void InitializeComponent()
    {
        components         = new Container();
        okButton           = new Button();
        cancelButton       = new Button();
        sitenameLabel      = new Label();
        addressLabel       = new Label();
        descriptionLabel   = new Label();
        sitenameTextbox    = new TextBox();
        addressTextbox     = new TextBox();
        descriptionTextbox = new TextBox();

        okButton.Text         = "OK";
        okButton.Location     = new Point(120, 168);
        okButton.Size         = new Size(75, 23);
        okButton.DialogResult = DialogResult.OK;
        okButton.TabIndex     = 6;

        cancelButton.Text         = "Cancel";
        cancelButton.Location     = new Point(256, 168);
        cancelButton.Size         = new Size(75, 23);
        cancelButton.DialogResult = DialogResult.Cancel;
        cancelButton.TabIndex     = 7;

        sitenameLabel.Text      = "Site Name:";
        sitenameLabel.Location  = new Point(24, 24);
        sitenameLabel.Size      = new Size(64, 20);
        sitenameLabel.TextAlign =
            ContentAlignment.MiddleRight;
        sitenameLabel.TabIndex  = 0;

        sitenameTextbox.Location = new Point(96, 24);
        sitenameTextbox.Size     = new Size(344, 20);
        sitenameTextbox.TabIndex = 3;

        addressLabel.Text      = "Address:";
        addressLabel.Location  = new Point(24, 72);
        addressLabel.Size      = new Size(64, 20);
        addressLabel.TextAlign =
            ContentAlignment.MiddleRight;
        addressLabel.TabIndex  = 1;

        addressTextbox.Location = new Point(96, 72);
        addressTextbox.Size     = new Size(344, 20);
        addressTextbox.TabIndex = 4;

        descriptionLabel.Text      = "Description:";
        descriptionLabel.Location  = new Point(24, 120);
        descriptionLabel.Size      = new Size(64, 20);
        descriptionLabel.TextAlign =
            ContentAlignment.MiddleRight;
        descriptionLabel.TabIndex  = 2;

        descriptionTextbox.Location = new Point(96, 120);
        descriptionTextbox.Size     = new Size(344, 20);
        descriptionTextbox.TabIndex = 5;

        Text       = "Add Form";
        ClientSize = new Size(464, 213);
        Controls.Add(descriptionTextbox);
        Controls.Add(addressTextbox);
        Controls.Add(sitenameTextbox);
        Controls.Add(cancelButton);
        Controls.Add(okButton);
        Controls.Add(descriptionLabel);
        Controls.Add(addressLabel);
        Controls.Add(sitenameLabel);
    }
}
