using System;
using System.IO;
using System.Text;
using System.Security.Cryptography;

class Crypto
{
	static void Main(string[] args)
	{
		string fileName   = "encryptedtext.txt";
		string passPhrase = "Wouldn't you like to know!";

		FileStream fStream = new FileStream(fileName, FileMode.OpenOrCreate, FileAccess.Write);

		byte[] writeBuffer = new byte[1024]; 
		byte[] key         = new Byte[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16 };
		byte[] initVect    = new Byte[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16 };
 
		RijndaelManaged rijn = new RijndaelManaged();

		CryptoStream encStream = new CryptoStream(fStream, rijn.CreateEncryptor(key, initVect), CryptoStreamMode.Write);

		Console.WriteLine("\nEncrypting Phrase: {0} - to file: {1}\n", passPhrase, fileName);

		ASCIIEncoding byteConverter = new ASCIIEncoding();
		writeBuffer = byteConverter.GetBytes(passPhrase);

		encStream.Write(writeBuffer, 0, passPhrase.Length);
  
		fStream.Close();

		fStream = new FileStream(fileName, FileMode.Open, FileAccess.Read);

		byte[] encBuffer = new byte[100];

		fStream.Read(encBuffer, 0, passPhrase.Length);
		string readResult = byteConverter.GetString(encBuffer);

		Console.WriteLine("Encrypted Text: {0}\n", readResult);

		fStream.Seek(0, SeekOrigin.Begin);

		CryptoStream decStream = new CryptoStream(fStream, rijn.CreateDecryptor(key, initVect), CryptoStreamMode.Read);

		byte[] readBuffer = new byte[passPhrase.Length];

		decStream.Read(readBuffer, 0, passPhrase.Length);
		readResult = byteConverter.GetString(readBuffer);

		Console.WriteLine("Decrypted Text: {0}\n", readResult);

		Console.ReadLine();
		fStream.Close(); 
	}
}
