using System;
using System.Collections;

/// <summary>
///		BitArray Example.
/// </summary>
class BitArrayExample
{
	static void Main(string[] args)
	{
		BitArray ba = new BitArray(4);

		ba[0] = true;
		ba[1] = false;
		ba[2] = true;

		Console.WriteLine("\nBefore xor...\n");

		foreach(bool bval in ba) 
		{
			Console.WriteLine("BitArray: {0}", bval);
		}

		ba.Xor(new BitArray(new bool[] {true, true, true, true}));

		Console.WriteLine("\nAfter xor...\n");

		foreach(bool bval in ba) 
		{
			Console.WriteLine("BitArray: {0}", bval);
		}

		Console.ReadLine();
	}
}
