using System;
using WebSites;

/// <summary>
///		Uses the SiteList Collection.
/// </summary>
class SiteManager
{
	SiteList sites = new SiteList();

	public SiteManager() 
	{
		sites = new WebSites.SiteList();
		sites[sites.Count] = new WebSite("Joe", "http://www.mysite.com", "Great Site!");
		sites[sites.Count] = new WebSite("Don", "http://www.dondotnet.com", "okay.");
		sites[sites.Count] = new WebSite("Bob", "www.bob.com", "No http://");
	}

	static void Main(string[] args)
	{
		SiteManager sm = new SiteManager();

		foreach (WebSite site in sm.sites) 
		{
			Console.WriteLine("Site: {0}", site);
		}

		Console.ReadLine();
	}
}
