using System;
using System.Resources;
using System.Collections;

namespace ResRead
{
	/// <summary>
	/// Resource Reading Example
	/// </summary>
	class ResRead
	{
		static void Main(string[] args)
		{
			IResourceReader resReader = new ResourceReader("strings.resources");
			IDictionaryEnumerator resEnumerator = resReader.GetEnumerator();

			while (resEnumerator.MoveNext()) 
			{
				Console.WriteLine("{0} = {1}", resEnumerator.Key, resEnumerator.Value);
			}
			resReader.Close();
		}
	}
}
