using System;
using System.Reflection;
using System.EnterpriseServices;

[assembly: ApplicationName("CPPool")]

[assembly: AssemblyKeyFileAttribute(@"..\..\CPPool.snk")]

namespace ComPlusServices
{
	/// <summary>
	/// COM+ Transaction Service.
	/// </summary>
	[ObjectPooling(Enabled=true, 
		 MinPoolSize=5, MaxPoolSize=11)]
	public class CPPool : ServicedComponent
	{
		public CPPool()
		{
		}

		public override void Activate()
		{
		}

		public override void Deactivate()
		{
		}

		public override bool CanBePooled()
		{
			return true;
		}
	}
}


