using System;
using System.Runtime.InteropServices;
using System.Reflection;

namespace TalkToComLater
{
	/// <summary>
	/// Makes a late bound call to a COM Component.
	/// </summary>
	class CallComLater
	{
		static void Main(string[] args)
		{
			Type lateBoundType 
				= Type.GetTypeFromProgID("ComObj.Com4DotNet");

			object lateBoundObject 
				= Activator.CreateInstance(lateBoundType);

			lateBoundType.InvokeMember(
							"GetResponseFromCom",
							BindingFlags.Default|
							BindingFlags.InvokeMethod,
							null,
							lateBoundObject,
							null);

			Console.ReadLine();
		}
	}
}
