using System;
using CrossLangCPP;
using CrossLangVB;

namespace CrossLangCS
{
	/// <summary>
	/// Cross Language Program Implementation
	/// </summary>
	class clCS: clCPP, clVB
	{
		clJS myJScriptObj = new clJS();

		static void Main(string[] args)
		{
			clCS myCrossLangObj = new clCS();

			Console.WriteLine(myCrossLangObj.myJScriptObj.Greeting);
			Console.ReadLine();
		}

		/// <summary>
		/// Overrides a C++ virtual method
		/// </summary>
		public override int CppMethod(int intParam)
		{
			return 0;
		}

		/// <summary>
		/// Implements a VB interface method
		/// </summary>
		public int VBInterfaceMethod()
		{
			return 0;
		}
	}
}
